c ------ Subroutine H_TABLE --------------------------------------------
c   1D, 2D, or 3D table of eigenvalue
c
c     Author: Thorwald Herbert, OSU, 1988
c
c ----------------------------------------------------------------------

      subroutine htable(iev1,iev2,idev,indt)
#include "common.ins"
      common /params/ con(0:ncon),par(npar),dpar(npar,2),ipar(npar,2),
     |                itask
      common /names/  conname(0:ncon),parname(npar),varname(nvar),
     |                problem
      character*8 conname,parname,varname
      character*80 problem
      dimension parin(npar),kpar(3),kstep(3),step(3)

c read number of dimensions (1 <= kdim <= 3)

      read (iopars,*) kdim
      if (kdim.lt.1.or.kdim.gt.3.or.kdim.gt.npar-2) then
         print*,'H_TABLE: Improper dimension of the table'
         stop
      endif

c read parameter, number of steps, and step size

      do 1 k=1,3
         if (k.le.kdim) then
            read (iopars,*) kpar(k),kstep(k),step(k)
            if (kpar(k).eq.iev1.or.kpar(k).eq.iev2) then
               print*,'H_TABLE: Eigenvalue chosen as parameter'
               stop
            endif
            if (k.gt.1) then
               do 2 l=1,k-1
                  if (kpar(k).eq.kpar(l)) then
                  print*,'H_TABLE: Parameter used twice'
                  stop
               endif
2              continue
            endif
         else
            kstep(k)=0
         endif
1     continue

c print header, save current point as initial point

      write(iologi,*)
      write(iologi,*)itask,' /task: table'
      write(iologi,*)kdim,' /dimension of the table'
      do 3 k=1,kdim
         write(iologi,'(i2,1x,i5,1pe15.7,
     |        35h /parameter, number & size of steps)')
     |        kpar(k),kstep(k),step(k)
3     continue

      print*
      print*,'Table of Eigenvalues ',parname(iev1),' ',parname(iev2)
      print 2000,(parname(m),m=1,npar)
2000  format (/8(4x,a8,3x))
      open(iotabl,file='O.table',status='unknown')
      rewind(iotabl)
      write(iotabl,*)'Table of Eigenvalues ',parname(iev1),' ',
     |               parname(iev2)
      write(iotabl,2000)(parname(m),m=1,npar)
      write(iologo,*)
      write(iologo,*)'Table of Eigenvalues ',parname(iev1),' ',
     |               parname(iev2)
      write(iologo,2000)(parname(m),m=1,npar)

      do 4 m=1,npar
         parin(m)=par(m)
4     continue
      parev31=par(iev1)
      parev32=par(iev2)
      parev21=par(iev1)
      parev22=par(iev2)

c loop through table

      do 5 k3=0,kstep(3)
         if (kdim.ge.3) then
            par(kpar(3))=parin(kpar(3))+k3*step(3)
            par(iev1)=parev31
            par(iev2)=parev32
            if (ipar(kpar(3),1).eq.2) call bstate
         endif
         do 5 k2=0,kstep(2)
            if (kdim.ge.2) then
               par(kpar(2))=parin(kpar(2))+k2*step(2)
               par(iev1)=parev21
               par(iev2)=parev22
               if (ipar(kpar(2),1).eq.2) call bstate
            endif
            print*
            write(iologo,*)
            do 5 k1=0,kstep(1)
               if (k1.ne.0.or.k2.ne.0.or.k3.ne.0) then
                  par(kpar(1))=parin(kpar(1))+k1*step(1)
                  if (ipar(kpar(1),1).eq.2) call bstate
                  if (iev1+1.eq.iev2.and.ipar(iev1,2).eq.1
     |                              .and.ipar(iev2,2).eq.2) then

                     call hlocal(idev,indt,iter)

                  else

                     call hlocalr(idev,indt,iter)

                  endif
               endif
               print 2001,(par(m),m=1,npar)
2001           format (1p8e15.7)
               write(iotabl,2001)(par(m),m=1,npar)
               write(iologo,2001)(par(m),m=1,npar)
               if (k1.eq.0) then
                  parev21=par(iev1)
                  parev22=par(iev2)
                  if (k2.eq.0) then
                     parev31=par(iev1)
                     parev32=par(iev2)
                  endif
               endif
5     continue
      close(iotabl)
      return
      end
