c ------ Main Program LINEAR -------------------------------------------
c
c     Author: Thorwald Herbert, OSU, 1988
c
c ----------------------------------------------------------------------

      program linear
c**********************************************************************
c Perform 64-bit arithmetic
      IMPLICIT REAL*8 (A-H, O-Z)   

c Number of collocation points JX
      PARAMETER (JX= 46)

c Number of equations and variables
      PARAMETER (NEQU= 2)
      parameter (nvar=nequ, isize=(jx+1)*nequ)

c Highest derivative nx
      PARAMETER (NX= 4)

c Number of constants (or zero)
      PARAMETER (NCON= 0)

c Number of parameters
      PARAMETER (NPAR= 5)
c **********************************************************************
c Numbers of input/output units
      parameter (iodefs=99)
      parameter (iopars=98)                
      parameter (iologi=97)
      parameter (iologo=96)
      parameter (iospec=95)
      parameter (iofunc=94)
      parameter (ioseri=93)
      parameter (iotabl=92)
      parameter (iocurv=91)
      PARAMETER (IOSTAT=80)
      parameter (iomodu=90)
c **********************************************************************
c Arrays for basic state
      COMMON /MSTATE/  FB(0:JX,0:6) 
c **********************************************************************
      common /contrl/ idsy(nvar),idbc(nvar),idpts,idtrf,atrf,btrf
      common /params/ con(0:ncon),par(npar),dpar(npar,2),ipar(npar,2),
     |                itask
      common /names/  conname(0:ncon),parname(npar),varname(nvar),
     |                problem
      common /collot/ chx(0:jx),chtx(0:jx,0:2*jx+nx+1,0:nx)
     &                         ,chty(0:jx,0:2*jx+nx+1,0:nx)
      common /collof/ chy(0:jx),chfy(0:jx,0:jx,0:nx,1:nvar)
      common /funct/  phys(0:jx,0:nx,1:nvar)
      character*8 conname,parname,varname
      character*80 problem

c open log-files to append input and output


c read the control parameters

      open(unit=iodefs,file='Definitions')
      rewind(iodefs)
      read (iodefs,'(a80)')problem
      read (iodefs,*)(idsy(i),i=1,nvar)
      read (iodefs,*)(idbc(i),i=1,nvar)
      read (iodefs,*)idpts
      read (iodefs,*)idtrf,atrf,btrf
      do 4 i=2,nvar
         if (idsy(1).lt.0.and.idsy(i).ge.0
     |   .or.idsy(1).ge.0.and.idsy(i).lt.0) then
            print*,' INPUT ERROR: Wrong symmetries'
            stop
         endif
4     continue
      do 5 i=1,nvar
         if (idbc(i).lt.0.or.idbc(i).gt.3) then
            print*,' INPUT ERROR: Wrong boundary conditions'
            stop
         endif
5     continue

c save definitions

      print '(/1x,a80/)',problem
      print*,' ',jx,nx,nequ,npar,ncon,' /jx,nx,nequ=nvar,npar,ncon'
      print*,' ',(idsy(n),n=1,nvar),' /idsy(nvar)'
      print*,' ',(idbc(n),n=1,nvar),' /idbc(nvar)'
      print*,' ',idpts,' /idpts'
      print*,' ',idtrf,atrf,' /idtrf,atrf'
      print*,'   ',btrf,' /btrf'
      write(iologo,'(/1x,a80/)')problem
      write(iologo,*)' ',jx,nx,nequ,npar,ncon,
     |               ' /jx,nx,nequ=nvar,npar,ncon'
      write(iologo,*)' ',(idsy(n),n=1,nvar),' /idsy(nvar)'
      write(iologo,*)' ',(idbc(n),n=1,nvar),' /idbc(nvar)'
      write(iologo,*)' ',idpts,' /idpts'
      write(iologo,*)' ',idtrf,atrf,' /idtrf,atrf'
      write(iologo,*)'   ',btrf,' /btrf'

c if ncon > 0: read names and values of constants

      if (ncon.gt.0) then
         read (iodefs,'(a8,1x,e16.8)')(conname(i),con(i),i=1,ncon)
         print '(/11h Constants:/)'
         print 2000,(conname(i),con(i),i=1,ncon)
2000     format(2x,a8,' = ',1pe14.7)
         write(iologo,'(/11h Constants:/)')
         write(iologo,2000)(conname(i),con(i),i=1,ncon)
      endif

c read variable names

      read (iodefs,'(a8)')(varname(i),i=1,nvar)

c read parameter names and identifiers

      do 6 i=1,npar
         read (iodefs,'(a8,1x,i2,1x,i2)')parname(i),ipar(i,1),ipar(i,2)
6     continue
      close(iodefs)

c end of the definitions
c read what should be done

7     idev=-1
      open(unit=iopars,file='Parameters')
      rewind(iopars)
      read (iopars,*,end=999)itask
      if (itask.lt.-1.or.itask.gt.4) then
         stop
      else if (itask.lt.0) then
         close(iopars)
         pause
         go to 7
      endif
      mtask=0
12    if (itask.gt.2.and.mtask.eq.0) then
         print*,'LINEAR: cant do task',itask,' before tasks 1 or 2'
         stop
      else if (itask.eq.0) then
         read (iopars,*) iev1
         iev2=iev1+1
      else
         read (iopars,*) iev1,iev2
      endif
      if (iev1.lt.1.or.iev1.gt.npar.or.iev2.lt.1.or.iev2.gt.npar) then
         print*,'LINEAR: Improper parameter chosen as eigenvalue'
         stop
      endif
      if (iev1+1.eq.iev2.and.ipar(iev1,2).eq.1
     |                  .and.ipar(iev2,2).eq.2) then
         indc=1
      else
         indc=0
      endif
      indt=max(ipar(iev1,1),ipar(iev2,1))

c read actual parameters

      print '(/12h Parameters:/)'
      write(iologo,'(/12h Parameters:/)')
      do 8 i=1,npar
      read (iopars,*) par(i)
      if (i.eq.iev1) then
         dpar(i,1)=1
         dpar(i,2)=0
         if (itask.eq.0) par(i)=0
      else if (i.eq.iev2) then
         dpar(i,1)=0
         dpar(i,2)=1
         if (itask.eq.0) par(i)=0
      else
         dpar(i,1)=0
         dpar(i,2)=0
         print 2000,parname(i),par(i)
         write(iologo,2000)parname(i),par(i)
      endif
8     continue
      print*
      write(iologo,*)

c call subroutines for spectral method

      call chinit(idsy(1),idpts)
      call chxtoy(idsy(1),idtrf,atrf,btrf)
      do 9 i=1,nvar
         call chttof(i,idsy(i),idbc(i))
9     continue

c set arrays for basic state

      call bstate

c perform the required task

13     if (itask.eq.0) then
         write(iologi,*)
         write(iologi,*)itask,' /task: spectrum'
         write(iologi,*)iev1,' /eigenvalue'
         write(iologi,'(1pe14.7,2h /,i2,1x,a8)')
     |        (par(i),i,parname(i),i=1,npar)

         print*,'Global Procedure, Eigenvalue = ',
     |          parname(iev1),' ',parname(iev2)
         write(iologo,*)'Global Procedure, Eigenvalue = ',
     |                  parname(iev1),' ',parname(iev2)

         open(iospec,file='O.spectrum',status='unknown')
         rewind(iospec)
         write(iospec,*)'Spectrum'
         write(iospec,*)
         do 10 i=1,npar
            if (i.ne.iev1.and.i.ne.iev2)
     |      write(iospec,'(2x,a8,3h = ,1pe14.7)')parname(i),par(i)
10       continue
         write(iospec,'(/2(5h   No,6x,a8,9x,a8,3x))')
     |         parname(iev1),parname(iev2),parname(iev1),parname(iev2)

         call hglobal(indt,indc)

      else if (itask.ge.1.and.itask.le.2) then
         write(iologi,*)
         if (itask.eq.1) write(iologi,*)itask,' /task: eigenvalue'
         if (itask.eq.2) write(iologi,*)itask,' /task: eigenfunction'
         write(iologi,*)iev1,iev2,' /eigenvalue'
         write(iologi,'(1pe14.7,2h /,i2,1x,a8)')
     |        (par(i),i,parname(i),i=1,npar)

         print*,'Local Procedure, Eigenvalue = ',
     |          parname(iev1),' ',parname(iev2)
         print*
         write(iologo,*)'Local Procedure, Eigenvalue = ',
     |                  parname(iev1),' ',parname(iev2)
         write(iologo,*)
         if (indc.eq.1) then

            call hlocal(idev,indt,iter)

         else

            call hlocalr(idev,indt,iter)

         endif
         print 2000,parname(iev1),par(iev1)
         print 2000,parname(iev2),par(iev2)
         write(iologo,2000)parname(iev1),par(iev1)
         write(iologo,2000)parname(iev2),par(iev2)
         if (itask.eq.2) then
            print*
            write(iologo,*)
            open(iofunc,file='O.function',status='unknown')
            rewind(iofunc)
            write(iofunc,*) 'Eigenfunction'
            write(iofunc,'(/(2x,a8,3h = ,1pe14.7))')
     |           (parname(i),par(i),i=1,npar)
            write(iofunc,*)
            open(ioseri,file='O.series',status='unknown')
            rewind(ioseri)
            write(ioseri,*) 'Eigenfunction'
            write(ioseri,'(/(2x,a8,3h = ,1pe14.7))')
     |           (parname(i),par(i),i=1,npar)
            write(ioseri,*)
            print*
            write(iomodu,*)
            open(iomodu,file='O.modulus',status='unknown')
            rewind(iomodu)
            write(iomodu,*) 'Modulus '
            write(iomodu,'(/(2x,a8,3h = ,1pe14.7))')
     &           (parname(i),par(i),i=1,npar)

            call hvalues

            call vfunction

         endif
         mtask=itask
      else if (itask.eq.3) then

         call htable(iev1,iev2,idev,indt)

      else if (itask.eq.4) then

         call hcurve(idev)

      endif
11    read (iopars,*,end=999) itask
      if (itask.lt.-1.or.itask.gt.4) then
         stop
      else if (itask.lt.0) then
         close(iopars)
         pause
         open(unit=iopars,file='Parameters')
         rewind (iopars)
         go to 11
      else if (itask.ge.0.and.itask.le.2) then
         go to 12
      endif
      go to 13

999   print*
      stop
      end
