c ------ Subroutine H_VALUES -------------------------------------------
c Print variables in spectral and physical space (F and T coefficients)
c
c     Author: Thorwald Herbert, OSU, 1988
c
c ----------------------------------------------------------------------

      subroutine hvalues
#include "common.ins"
      common /collot/ chx(0:jx),chtx(0:jx,0:2*jx+nx+1,0:nx)
     |                         ,chty(0:jx,0:2*jx+nx+1,0:nx)
      common /collof/ chy(0:jx),chfy(0:jx,0:jx,0:nx,1:nvar)
      common /contrl/ idsy(nvar),idbc(nvar),idpts,idtrf,atrf,btrf
      common /coeffs/ coef(0:jx,1:nvar)
      common /coeffn/ coefn(0:jx,1:nvar),coetn(0:jx+nx,1:nvar),
     |                jxt(1:nvar)
      common /params/ con(0:ncon),par(npar),dpar(npar,2),ipar(npar,2),
     |                itask
      common /names/  conname(0:ncon),parname(npar),varname(nvar),
     |                problem
      common /funct/  phys(0:jx,0:nx,1:nvar)
      character*8 conname,parname,varname
      character*80 problem
#ifdef CRAY
      complex coef,coefn,coetn,phys,zero,div,zz
#else
      complex*16 coef,coefn,coetn,phys,zero,div,zz
#endif

      zro=0
      zero=cmplx(zro,zro)

c find norm: sum coefn^2 = 1

      div=zero
      do 1 n=1,nvar
         do 1 k=0,jx
         div=div+coef(k,n)**2
1     continue
      div=sqrt(div)

c provide for symmetry

      do 2 n=1,nvar
      print*, 'Series for ',varname(n),'  (l,T[l],k,F[k])'
      write(ioseri,*) 'Series for ',varname(n),'  (l,T[l],k,F[k])'
      write(iologo,*) 'Series for ',varname(n),'  (l,T[l],k,F[k])'
      if (idsy(n).lt.0) then
         k0=0
         k1=1
      else if (idsy(n).eq.0) then
         k0=0
         k1=2
      else
         k0=1
         k1=2
      endif

c transform coefficients in F into coefficients in T

        do 3 k=0,jx+nx
3       coetn(k,n)=zero
        do 4 k=0,jx
          coefn(k,n)=coef(k,n)/div
          l=k0+k*k1
          go to (10,11,12,13),idbc(n)+1

c for definitions of F see subroutine chttof.f
c no boundary condition

10        coetn(k,n)=coefn(k,n)
          go to 5

c boundary condition 1: f(a)=f(b)=0

11        coetn(k     ,n)=coetn(k     ,n)+coefn(k,n)
          coetn(k+2/k1,n)=coetn(k+2/k1,n)-coefn(k,n)
          go to 5

c boundary condition 2: f'(a)=f'(b)=0

12        coetn(k     ,n)=coetn(k     ,n)+coefn(k,n)*(l+2)**2/(l+1)**2
          coetn(k+2/k1,n)=coetn(k+2/k1,n)-coefn(k,n)*l**2/(l+1)**2
          go to 5

c boundary condition 3: f(a)=f(b)=f'(a)=f'(b)=0

13        coetn(k     ,n)=coetn(k     ,n)+coefn(k,n)*(l+3)/(2*l+4)
          coetn(k+2/k1,n)=coetn(k+2/k1,n)-coefn(k,n)
          coetn(k+4/k1,n)=coetn(k+4/k1,n)+coefn(k,n)*(l+1)/(2*l+4)

5         print 2000,l,coetn(k,n),k,coefn(k,n)
2000      format(2(i4,1p2e16.7))
          write(ioseri,2000)l,coetn(k,n),k,coefn(k,n)
          write(iologo,2000)l,coetn(k,n),k,coefn(k,n)
4       continue
        if (idbc(n).gt.0) then
          if (idbc(n).lt.2) then
             jxt(n)=jx+2/k1
          else
             jxt(n)=jx+4/k1
          endif
          do 6 j=jx+1,jxt(n)
             print 2000,k0+j*k1,coetn(j,n)
             write(ioseri,2000)k0+j*k1,coetn(j,n)
             write(iologo,2000)k0+j*k1,coetn(j,n)
6         continue
        else
          jxt(n)=jx
        endif

      print*
      write(iologo,*)
2     continue

c function values at collocation points

      do 7 l=1,nvar
      print*, 'Values of ',varname(l),' (j,x,y,value)'
      write(iofunc,*) 'Values of ',varname(l),' (j,x,y,value)'
      write(iologo,*) 'Values of ',varname(l),' (j,x,y,value)'
        do 8 j=0,jx
          do 9 n=0,nx
            phys(j,n,l)=zero
            do 9 k=0,jx
              phys(j,n,l)=phys(j,n,l)+coefn(k,l)*chfy(j,k,n,l)
9         continue
          print'(i4,1p4e15.7)/(34x,2e15.7)',
     |    j,chx(j),chy(j),(phys(j,n,l),n=0,0)
          write(iofunc,'(i4,1p4e15.7)/(34x,2e15.7)')
     |    j,chx(j),chy(j),(phys(j,n,l),n=0,0)
          write(iologo,'(i4,1p4e15.7)/(34x,2e15.7)')
     |    j,chx(j),chy(j),(phys(j,n,l),n=0,0)
8       continue
      if (l.eq.nvar) go to 7 
      print*
      write(iologo,*)
7     continue
      close(iofunc)
      return
      end
