/* Perform 64-bit arithmetic */
#ifdef CRAY
#define ZERO 0.0E0
#define D_CONJG CONJG
#define C_MPLEX COMPLEX
#else
#define ZERO 0.0D0
#define D_CONJG DCONJG
#define C_MPLEX COMPLEX*16
#endif
C **********************************************************************
C
C  C_MPLEX FUNCTION ZDOTC
C
C **********************************************************************
      FUNCTION ZDOTC(N,ZX,INCX,ZY,INCY)
      C_MPLEX zdotc
C
C     FORMS THE DOT PRODUCT OF A VECTOR.
C     JACK DONGARRA, 3/11/78.
C
 
c Perform 64-bit arithmetic
#ifdef CRAY
      REAL D_CONJG
#else
      DOUBLE PRECISION D_CONJG
#endif

      C_MPLEX ZX(N),ZY(N),ZTEMP
      ZTEMP = (ZERO,ZERO)
      ZDOTC = (ZERO,ZERO)
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        ZTEMP = ZTEMP + D_CONJG(ZX(IX))*ZY(IY)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      ZDOTC = ZTEMP
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
   20 DO 30 I = 1,N
        ZTEMP = ZTEMP + D_CONJG(ZX(I))*ZY(I)
   30 CONTINUE
      ZDOTC = ZTEMP
      RETURN
      END
