c ------ Subroutine B_STATE --------------------------------------------
c Set the basic state for use in P_VECTOR, Q_VECTOR
c     The jx collocation points are in chy(0:jx)
c
c     Author: Thorwald Herbert, OSU, 1988
c
c ----------------------------------------------------------------------

      subroutine bstate
c **********************************************************************
c Perform 64-bit arithmetic
      implicit real*8 (a-h,o-z)

c Number of collocation points jx
      PARAMETER (JX= 8)

c Number of equations and variables
      PARAMETER (NEQU= 2)
      parameter (nvar=nequ,isize=(jx+1)*nequ)

c Highest derivative nx
      PARAMETER (NX= 4)

c Number of constants (or zero)
      PARAMETER (NCON= 0)

c Number of parameters
      PARAMETER (NPAR= 4)
c **********************************************************************
c Numbers of input/output units
      parameter (iodefs=99)
      parameter (iopars=98)
      parameter (iologi=97)
      parameter (iologo=96)
      parameter (iospec=95)
      parameter (iofunc=94)
      parameter (ioseri=93)
      parameter (iotabl=92)
      parameter (iocurv=91)
c **********************************************************************
c Arrays for basic state
      COMMON /MSTATE/ GM(0:JX),GMDERIV(0:JX)
c **********************************************************************
      common /collof/ chy(0:jx),chfy(0:jx,0:jx,0:nx,1:nvar)
      common /params/ con(0:ncon),par(npar),dpar(npar),ipar(npar),
     |                itask
      common /names/  conname(0:ncon),parname(npar),varname(nvar),
     |                problem
      character*8 conname,parname,varname
      character*80 problem
c
c      do 1 j=0,jx

c ***********************************************************************
c ***********************************************************************
c CASE: Circular Couette flow in a small gap
c
c          G(y)=1+(omega-1)y

      do 1 j=0,jx
         OMEGA=PAR(1)
         GM(J)=1+(OMEGA-1)*CHY(J)
         GMDERIV(J)=CHY(J)
1     continue
c ***********************************************************************
c ***********************************************************************

c1     continue
      return
      end
